var f = Object.defineProperty;
var j = (l, e, t) => e in l ? f(l, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : l[e] = t;
var R = (l, e, t) => (j(l, typeof e != "symbol" ? e + "" : e, t), t);
import { A as q } from "./app-automate-zSBbQYkM.js";
import { F as x } from "./app-automate-zSBbQYkM.js";
import { A as w, B as d } from "./api-client-JEr5hMvW.js";
import { L as I, a as G } from "./local-testing-binary-PR2N43Or.js";
class S extends w {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(e) {
    return this.makePutRequest("/automate/recycle_key.json", e);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(e) {
    return this.makeGetRequest("/automate/plan.json", e);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/automate/browsers.json", e);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(e) {
    return this.makeGetRequest("/automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new d(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(e, t) {
    return this.makeDeleteRequest("/automate/builds", {
      ...t,
      params: {
        query: {
          "buildId[]": e
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(e, t, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: e
        },
        query: t
      }
    }).then((a) => a.map((o) => o.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(e, t, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(e, t) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...t,
      params: {
        query: {
          "sessionId[]": e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (a) => {
          const o = new FormData();
          return o.append("file", a.file, t.filename), o;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (a) => {
          const o = new FormData();
          return o.append("file", a.file, t.filename), o;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(e, t) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...t,
        params: {
          path: {
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param data - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const a = new FormData();
        return a.append("file", s.file, e.filename), a;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(e) {
    return this.makeGetRequest("/automate/recent_media_files", e);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...t,
      params: {
        path: {
          mediaId: e
        }
      }
    });
  }
}
class b extends w {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  /**
   * Retrieves the account status.
   *
   * @returns A Promise that resolves to the account status.
   */
  getAccountStatus() {
    return this.makeGetRequest("/status");
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(e, t) {
    return this.makeGetRequest("/browsers", {
      ...t,
      params: {
        query: {
          ...e,
          flat: typeof (e == null ? void 0 : e.flat) == "boolean" ? e.flat : !0
        }
      }
    });
  }
  /**
   * Creates a worker for JS testing.
   *
   * @param body - The request body.
   * @param options - The API fetch options.
   * @returns A promise that resolves to the worker response.
   */
  createWorker(e, t) {
    return this.makePostRequest("/worker", {
      ...t,
      body: e
    });
  }
  /**
   * Retrieves a list of workers.
   *
   * @param options - Optional parameters for the API request.
   * @returns A promise that resolves to an array of Worker objects.
   */
  getWorkers(e) {
    return this.makeGetRequest("/workers", e);
  }
  /**
   * Retrieves a worker by its ID.
   *
   * @param workerId The ID of the worker.
   * @param options Additional options for the API request.
   * @returns A Promise that resolves to the retrieved worker.
   */
  getWorker(e, t) {
    return this.makeGetRequest("/worker/{workerId}", {
      ...t,
      params: {
        path: {
          workerId: e
        }
      }
    });
  }
  /**
   * Deletes a worker by worker ID.
   *
   * @param workerId The ID of the worker to delete.
   * @param options Optional API fetch options.
   * @returns A promise that resolves when the worker is deleted.
   */
  deleteWorker(e, t) {
    return this.makeDeleteRequest("/worker/{workerId}", {
      ...t,
      params: {
        path: {
          workerId: e
        }
      }
    });
  }
  /**
   * Updates the URL of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param body - The request body containing the updated URL.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves with the response from the server.
   */
  updateWorkerURL(e, t, s) {
    return this.makePutRequest("/worker/{workerId}/url.json", {
      ...s,
      params: {
        path: {
          workerId: e
        }
      },
      body: t
    });
  }
  /**
   * Takes a screenshot of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param format - The format of the screenshot (e.g., "png", "json", "xml").
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the screenshot data.
   */
  getWorkerScreenshot(e, t, s) {
    return this.makeGetRequest("/worker/{workerId}/screenshot.{format}", {
      ...s,
      params: {
        path: {
          workerId: e,
          format: t ?? "png"
        }
      },
      parseAs: t === "json" ? "json" : t === "xml" ? "text" : "arrayBuffer"
    });
  }
  /**
   * Awaits a worker with the specified workerId to attain "running" status.
   *
   * @param workerId - The ID of the worker to retrieve.
   * @param options - Optional API fetch options.
   * @param pollInterval - The interval (in milliseconds) at which to poll for the worker status. Default is 10000ms.
   * @returns A promise that resolves with the running worker.
   */
  ensureWorkerRunning(e, t, s = 1e4) {
    return new Promise((a, o) => {
      let r;
      const m = (u, p) => {
        var i;
        clearInterval(n), (i = r == null ? void 0 : r.abort) == null || i.call(r), u ? o(
          u instanceof d ? u : new d(u.message, u)
        ) : p && a(p);
      }, n = setInterval(async () => {
        r = t != null && t.signal ? void 0 : new AbortController();
        const u = await this.getWorker(e, {
          ...t,
          signal: (t == null ? void 0 : t.signal) ?? (r == null ? void 0 : r.signal)
        }).catch(m);
        u && (u.id ? u.status === "running" && m(void 0, u) : m(new d(`Worker ${e} is no longer running`)));
      }, s);
    });
  }
  /**
   * High-level abstraction for launching a worker-browser with the specified options.
   *
   * @param body The request body for creating the worker.
   * @param options The options for creating the worker.
   * @returns A promise that resolves to the launched worker.
   */
  async launch(e, t) {
    const { pollInterval: s, ...a } = t ?? {}, { id: o } = await this.createWorker(e, a), r = await this.ensureWorkerRunning(o, void 0, s), m = {
      ...r,
      updateURL: (n) => this.updateWorkerURL(r.id, { url: n }),
      getScreenshot: () => this.getWorkerScreenshot(r.id, "png"),
      getScreenshotURL: () => this.getWorkerScreenshot(r.id, "json").then((n) => n.url),
      terminate: async () => this.deleteWorker(r.id).then((n) => (m.status = void 0, n))
    };
    return m;
  }
}
const k = class k extends w {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/screenshots/browsers.json", e);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(e, t) {
    return this.makePostRequest("/screenshots", {
      ...t,
      body: e
    }).then((s) => ({
      ...s,
      id: s.job_id
    }));
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(e, t) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...t,
      params: {
        path: {
          jobId: e
        }
      }
    }).then((s) => ({
      ...s,
      id: s.id ?? s.job_id
    }));
  }
  /**
   * Tracks the progress of a screenshot job and retrieves the screenshots associated with it.
   *
   * @param jobId - The ID of the job to track.
   * @param onScreenshot - Optional callback function that will be called when a new screenshot is added to the result.
   * @param pollInterval - The interval (in milliseconds) at which the job status should be polled. Default is 10000ms.
   * @returns A promise that resolves with an array of screenshots when the job is completed.
   */
  trackJob(e, t, s, a = 1e4) {
    return new Promise((o, r) => {
      const m = /* @__PURE__ */ new Map();
      let n;
      const u = (i) => {
        var h;
        clearInterval(p), (h = n == null ? void 0 : n.abort) == null || h.call(n), i ? r(
          i instanceof d ? i : new d(i.message, i)
        ) : o(Array.from(m.values()));
      }, p = setInterval(async () => {
        n = s != null && s.signal ? void 0 : new AbortController();
        const i = await this.getJob(e, {
          ...s,
          signal: (s == null ? void 0 : s.signal) ?? (n == null ? void 0 : n.signal)
        }).catch(u);
        if (!i)
          return;
        const h = i.screenshots ?? [];
        for (const c of h)
          k.jobCompleteStates.includes(c.state) && (m.has(c.id) || m.set(c.id, c), await (t == null ? void 0 : t(c)));
        (i.state === "done" || h.length === m.size) && u();
      }, a);
    });
  }
  /**
   * Launches a screenshots job with the specified parameters.
   *
   * @param body - The request body for creating the screenshots job.
   * @param onScreenshot - Optional callback function to be called when a screenshot is available.
   * @param options - Optional options for the API fetch and job tracking, including pollInterval.
   * @returns A promise that resolves to the result of the job tracking.
   */
  async launch(e, t, s) {
    const { pollInterval: a, ...o } = s ?? {}, { id: r } = await this.createJob(e, o);
    return this.trackJob(r, t, void 0, a);
  }
};
/**
 * @internal
 */
R(k, "jobCompleteStates", ["done", "error"]);
let g = k;
const y = {
  AutomateClient: S,
  ScreenshotsClient: g,
  AppAutomateClient: q,
  JSTestingClient: b,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: b,
  LocalTestingClient: I
}, v = {
  ...y,
  LocalTestingBinary: G
};
export {
  q as AppAutomateClient,
  S as AutomateClient,
  v as BrowserStack,
  x as FlutterPlatform,
  b as JSTestingClient,
  G as LocalTestingBinary,
  I as LocalTestingClient,
  g as ScreenshotsClient
};
